Attribute VB_Name = "API"
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Private Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long
Declare Function SendMessageByString Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long

Public Const LB_FINDSTRINGEXACT = &H1A2
Private Const GWL_EXSTYLE = (-20)
Private Const WS_EX_WINDOWEDGE = &H100
Private Const WS_EX_CLIENTEDGE = &H200
Private Const WS_EX_STATICEDGE = &H20000
Private Const SWP_SHOWWINDOW = &H40
Private Const SWP_HIDEWINDOW = &H80
Private Const SWP_FRAMECHANGED = &H20
Private Const SWP_NOACTIVATE = &H10
Private Const SWP_NOCOPYBITS = &H100
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOOWNERZORDER = &H200
Private Const SWP_NOREDRAW = &H8
Private Const SWP_NOREPOSITION = SWP_NOOWNERZORDER
Private Const SWP_NOSIZE = &H1
Private Const SWP_NOZORDER = &H4
Private Const SWP_DRAWFRAME = SWP_FRAMECHANGED
Private Const SWP_FLAGS = SWP_NOZORDER Or SWP_NOSIZE Or SWP_NOMOVE Or SWP_DRAWFRAME
Private Const HWND_NOTOPMOST = -2
'
Private Const BIF_RETURNONLYFSDIRS = &H1
Private Const BIF_DONTGOBELOWDOMAIN = &H2
Private Const BIF_STATUSTEXT = &H4
Private Const BIF_RETURNFSANCESTORS = &H8
Private Const BIF_BROWSEFORCOMPUTER = &H1000
Private Const BIF_BROWSEFORPRINTER = &H2000

' Guest Book
Public name As String
Public Comment As String

Private Type Conf
    HomePath As String
    HomePage As String
    Port As String
    EnableFormPost As String
    EnableCounter As String
    RunAtStartUp As String
    RunInTray As String
End Type



Private Type OPENFILENAME
    lStructSize As Long
    hWndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Private Type BROWSEINFO
    hOwner As Long
    pidlRoot As Long
    pszDisplayName As String
    lpszTitle As String
    ulFlags As Long
    lpfn As Long
    lParam As Long
    iImage As Long
End Type

Public Config As Conf
Function RemoveDupeItems(LstBox As ListBox) As Integer
Dim Counter As Integer
Dim StrLine As String
Dim Xpos As Integer
Dim YPos As Integer

For Counter = 0 To LstBox.ListCount - 1
Do
    DoEvents
    StrLine = LstBox.List(Counter)
    Xpos = SendMessageByString(LstBox.hwnd, LB_FINDSTRINGEXACT, Counter, StrLine)
    YPos = SendMessageByString(LstBox.hwnd, LB_FINDSTRINGEXACT, Xpos + 1, StrLine)
        If YPos = -1 Or YPos = Xpos Then Exit Do
            LstBox.RemoveItem YPos
Loop
Next Counter

    End Function
Function AddBackSlash(Pathname As String) As String
Dim TBackSlash As String

If Not Right(Pathname, 1) = "\" Then
    TBackSlash = Pathname & "\"
    Else
    TBackSlash = Pathname
End If
    AddBackSlash = TBackSlash
    
End Function
Function GetCGIFilename(lzstr As String) As String
Dim lpos, mStart As Integer
    For lpos = 1 To Len(lzstr)
        ch = Mid(lzstr, lpos, 1)
        If ch = "/" Then
            mStart = lpos
        End If
    Next
    GetCGIFilename = Trim(Mid(lzstr, mStart + 1, Len(lzstr)))
    
End Function
Function GetFileNameFromPath(ByVal Pathname As String) As String
Dim Xpos As Integer
 
 If Right(Pathname, 1) = "\" Then
   Exit Function
   Else
   For m_count = 1 To Len(Pathname)
    ch = Mid(Pathname, m_count, 1)
     
     If ch = "\" Then
        Xpos = m_count
     End If
     
    Next
     GetFileNameFromPath = Mid(Pathname, Xpos + 1, Len(Pathname))
     End If
     
End Function
Public Function FileExists(ByVal Filename As String) As Integer
    If Dir(Filename) = "" Then FileExists = 0 Else FileExists = 1
    
End Function
Public Function FolderExists(ByVal Foldername As String) As Integer
    If Dir(AddBackSlash(Foldername), vbDirectory) = "" Then FolderExists = 0 Else FolderExists = 1

End Function
Public Sub FlatBorder(ByVal hwnd As Long)
Dim TFlat As Long
    TFlat = GetWindowLong(hwnd, GWL_EXSTYLE)
    TFlat = TFlat And Not WS_EX_CLIENTEDGE Or WS_EX_STATICEDGE
    SetWindowLong hwnd, GWL_EXSTYLE, TFlat
    SetWindowPos hwnd, 0, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_NOZORDER Or SWP_FRAMECHANGED Or SWP_NOSIZE Or SWP_NOMOVE
  
End Sub
Function CenterForm(Frm As Form)
    With Frm
        .Top = (Screen.Height - Frm.Height) / 2
        .Left = (Screen.Width - Frm.Width) / 2
    End With
    
End Function
Function WriteINIChanges()
'EnableCounter
    SaveSetting "WebSer2k", "Config", "HomePath", Config.HomePath
    SaveSetting "WebSer2k", "Config", "HomePage", Config.HomePage
    SaveSetting "WebSer2k", "Config", "Port", Config.Port
    SaveSetting "WebSer2k", "Config", "EnablePost", Config.EnableFormPost
    SaveSetting "WebSer2k", "Config", "EnableCounter", Config.EnableCounter
    SaveSetting "WebSer2k", "Config", "RunAtStartUp", Config.RunAtStartUp
    SaveSetting "WebSer2k", "Config", "RunInTary", Config.RunInTray
    
End Function
Function ReadWriteINI()
    Config.HomePath = GetSetting("WebSer2k", "Config", "HomePath")
    Config.HomePage = GetSetting("WebSer2k", "Config", "HomePage")
    Config.Port = GetSetting("WebSer2k", "Config", "Port")
    Config.EnableFormPost = GetSetting("WebSer2k", "Config", "EnablePost")
    Config.EnableCounter = GetSetting("WebSer2k", "Config", "EnableCounter")
    Config.RunAtStartUp = GetSetting("WebSer2k", "Config", "RunAtStartUp")
    Config.RunInTray = GetSetting("WebSer2k", "Config", "RunInTary")
    
    If Config.HomePath = "" Then
        SaveSetting "WebSer2k", "Config", "HomePath", "C:\Webser2k\wwwroot\"
    End If

    If Config.HomePage = "" Then
        SaveSetting "WebSer2k", "Config", "HomePage", "Index.htm"
    End If

    If Config.Port = "" Then
        SaveSetting "WebSer2k", "Config", "Port", "80"
    End If
    
    If Config.EnableFormPost = "" Then
        SaveSetting "WebSer2k", "Config", "EnablePost", "1"
    End If
    
    If Config.RunAtStartUp = "" Then
        SaveSetting "WebSer2k", "Config", "RunAtStartUp", "0"
    End If
    
    If Config.RunInTray = "" Then
        SaveSetting "WebSer2k", "Config", "RunInTary", "0"
    End If
    
    If Config.EnableCounter = "" Then
        SaveSetting "WebSer2k", "Config", "EnableCounter", "1"
    End If
    
    
End Function
Private Function RemoveNulls(lzString As String) As String
Dim Xpos As Integer
    Xpos = InStr(lzString, vbNullChar)
    If Xpos > 0 Then
        lzString = Left(lzString, Len(lzString) - 1)
        RemoveNulls = lzString
    End If
    
End Function
Function GetFolder(ByVal hWndOwner As Long, ByVal sTitle As String) As String
Dim bInf As BROWSEINFO
Dim RetVal As Long
Dim PathID As Long
Dim RetPath As String
Dim Offset As Integer
    bInf.hOwner = hWndOwner
    bInf.lpszTitle = sTitle
    bInf.ulFlags = BIF_RETURNONLYFSDIRS
    PathID = SHBrowseForFolder(bInf)
    RetPath = Space$(512)
    RetVal = SHGetPathFromIDList(ByVal PathID, ByVal RetPath)
    If RetVal Then
      Offset = InStr(RetPath, Chr$(0))
      GetFolder = Left$(RetPath, Offset - 1)
    End If
End Function

Public Function OpenFile() As String
 Dim ofn As OPENFILENAME
    ofn.lStructSize = Len(ofn)
    ofn.hWndOwner = Form1.hwnd
    ofn.hInstance = App.hInstance
    ofn.lpstrFilter = "All Files(*.htm Internet Documents)" + Chr$(0) + "*.htm"
        ofn.lpstrFile = Space$(254)
        ofn.nMaxFile = 255
        ofn.lpstrFileTitle = Space$(254)
        ofn.nMaxFileTitle = 255
        ofn.lpstrInitialDir = App.Path & "\"
        ofn.lpstrTitle = "Open Internet Document"
        ofn.flags = 0
        
        a = GetOpenFileName(ofn)
        If (a) Then
                OpenFile = RemoveNulls(Trim(ofn.lpstrFile))
        End If
        
 End Function


